package com.hfkj.dao;

import com.hfkj.entity.BsMealShopCart;
import com.hfkj.entity.BsMealShopCartExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsMealShopCartMapper extends BsMealShopCartMapperExt {
    @SelectProvider(type=BsMealShopCartSqlProvider.class, method="countByExample")
    long countByExample(BsMealShopCartExample example);

    @DeleteProvider(type=BsMealShopCartSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsMealShopCartExample example);

    @Delete({
        "delete from bs_meal_shop_cart",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_meal_shop_cart (store_id, store_name, ",
        "serial_number, table_number, ",
        "`table_name`, order_no, ",
        "product_category_id, product_category_name, ",
        "product_id, product_img, ",
        "product_name, product_spec, ",
        "product_price, product_num, ",
        "product_total_price, `status`, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{storeId,jdbcType=BIGINT}, #{storeName,jdbcType=VARCHAR}, ",
        "#{serialNumber,jdbcType=VARCHAR}, #{tableNumber,jdbcType=INTEGER}, ",
        "#{tableName,jdbcType=VARCHAR}, #{orderNo,jdbcType=VARCHAR}, ",
        "#{productCategoryId,jdbcType=BIGINT}, #{productCategoryName,jdbcType=VARCHAR}, ",
        "#{productId,jdbcType=BIGINT}, #{productImg,jdbcType=VARCHAR}, ",
        "#{productName,jdbcType=VARCHAR}, #{productSpec,jdbcType=VARCHAR}, ",
        "#{productPrice,jdbcType=DECIMAL}, #{productNum,jdbcType=INTEGER}, ",
        "#{productTotalPrice,jdbcType=DECIMAL}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsMealShopCart record);

    @InsertProvider(type=BsMealShopCartSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsMealShopCart record);

    @SelectProvider(type=BsMealShopCartSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="store_name", property="storeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="serial_number", property="serialNumber", jdbcType=JdbcType.VARCHAR),
        @Result(column="table_number", property="tableNumber", jdbcType=JdbcType.INTEGER),
        @Result(column="table_name", property="tableName", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_category_id", property="productCategoryId", jdbcType=JdbcType.BIGINT),
        @Result(column="product_category_name", property="productCategoryName", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.BIGINT),
        @Result(column="product_img", property="productImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_name", property="productName", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_spec", property="productSpec", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_price", property="productPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="product_num", property="productNum", jdbcType=JdbcType.INTEGER),
        @Result(column="product_total_price", property="productTotalPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsMealShopCart> selectByExample(BsMealShopCartExample example);

    @Select({
        "select",
        "id, store_id, store_name, serial_number, table_number, `table_name`, order_no, ",
        "product_category_id, product_category_name, product_id, product_img, product_name, ",
        "product_spec, product_price, product_num, product_total_price, `status`, create_time, ",
        "update_time, ext_1, ext_2, ext_3",
        "from bs_meal_shop_cart",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="store_name", property="storeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="serial_number", property="serialNumber", jdbcType=JdbcType.VARCHAR),
        @Result(column="table_number", property="tableNumber", jdbcType=JdbcType.INTEGER),
        @Result(column="table_name", property="tableName", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_category_id", property="productCategoryId", jdbcType=JdbcType.BIGINT),
        @Result(column="product_category_name", property="productCategoryName", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.BIGINT),
        @Result(column="product_img", property="productImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_name", property="productName", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_spec", property="productSpec", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_price", property="productPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="product_num", property="productNum", jdbcType=JdbcType.INTEGER),
        @Result(column="product_total_price", property="productTotalPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsMealShopCart selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsMealShopCartSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsMealShopCart record, @Param("example") BsMealShopCartExample example);

    @UpdateProvider(type=BsMealShopCartSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsMealShopCart record, @Param("example") BsMealShopCartExample example);

    @UpdateProvider(type=BsMealShopCartSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsMealShopCart record);

    @Update({
        "update bs_meal_shop_cart",
        "set store_id = #{storeId,jdbcType=BIGINT},",
          "store_name = #{storeName,jdbcType=VARCHAR},",
          "serial_number = #{serialNumber,jdbcType=VARCHAR},",
          "table_number = #{tableNumber,jdbcType=INTEGER},",
          "`table_name` = #{tableName,jdbcType=VARCHAR},",
          "order_no = #{orderNo,jdbcType=VARCHAR},",
          "product_category_id = #{productCategoryId,jdbcType=BIGINT},",
          "product_category_name = #{productCategoryName,jdbcType=VARCHAR},",
          "product_id = #{productId,jdbcType=BIGINT},",
          "product_img = #{productImg,jdbcType=VARCHAR},",
          "product_name = #{productName,jdbcType=VARCHAR},",
          "product_spec = #{productSpec,jdbcType=VARCHAR},",
          "product_price = #{productPrice,jdbcType=DECIMAL},",
          "product_num = #{productNum,jdbcType=INTEGER},",
          "product_total_price = #{productTotalPrice,jdbcType=DECIMAL},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsMealShopCart record);
}