package com.hfkj.dao;

import com.hfkj.entity.BsMealTableOrder;
import com.hfkj.entity.BsMealTableOrderExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsMealTableOrderMapper extends BsMealTableOrderMapperExt {
    @SelectProvider(type=BsMealTableOrderSqlProvider.class, method="countByExample")
    long countByExample(BsMealTableOrderExample example);

    @DeleteProvider(type=BsMealTableOrderSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsMealTableOrderExample example);

    @Delete({
        "delete from bs_meal_table_order",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_meal_table_order (id, mer_id, ",
        "mer_no, mer_name, ",
        "mer_abbreviate, store_id, ",
        "store_name, serial_number, ",
        "table_number, `table_name`, ",
        "people_num, order_no, ",
        "order_amount, `status`, ",
        "pay_time, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{id,jdbcType=BIGINT}, #{merId,jdbcType=BIGINT}, ",
        "#{merNo,jdbcType=VARCHAR}, #{merName,jdbcType=VARCHAR}, ",
        "#{merAbbreviate,jdbcType=VARCHAR}, #{storeId,jdbcType=BIGINT}, ",
        "#{storeName,jdbcType=VARCHAR}, #{serialNumber,jdbcType=VARCHAR}, ",
        "#{tableNumber,jdbcType=INTEGER}, #{tableName,jdbcType=VARCHAR}, ",
        "#{peopleNum,jdbcType=INTEGER}, #{orderNo,jdbcType=VARCHAR}, ",
        "#{orderAmount,jdbcType=DECIMAL}, #{status,jdbcType=INTEGER}, ",
        "#{payTime,jdbcType=TIMESTAMP}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    int insert(BsMealTableOrder record);

    @InsertProvider(type=BsMealTableOrderSqlProvider.class, method="insertSelective")
    int insertSelective(BsMealTableOrder record);

    @SelectProvider(type=BsMealTableOrderSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_abbreviate", property="merAbbreviate", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="store_name", property="storeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="serial_number", property="serialNumber", jdbcType=JdbcType.VARCHAR),
        @Result(column="table_number", property="tableNumber", jdbcType=JdbcType.INTEGER),
        @Result(column="table_name", property="tableName", jdbcType=JdbcType.VARCHAR),
        @Result(column="people_num", property="peopleNum", jdbcType=JdbcType.INTEGER),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_amount", property="orderAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_time", property="payTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsMealTableOrder> selectByExample(BsMealTableOrderExample example);

    @Select({
        "select",
        "id, mer_id, mer_no, mer_name, mer_abbreviate, store_id, store_name, serial_number, ",
        "table_number, `table_name`, people_num, order_no, order_amount, `status`, pay_time, ",
        "create_time, update_time, ext_1, ext_2, ext_3",
        "from bs_meal_table_order",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_abbreviate", property="merAbbreviate", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="store_name", property="storeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="serial_number", property="serialNumber", jdbcType=JdbcType.VARCHAR),
        @Result(column="table_number", property="tableNumber", jdbcType=JdbcType.INTEGER),
        @Result(column="table_name", property="tableName", jdbcType=JdbcType.VARCHAR),
        @Result(column="people_num", property="peopleNum", jdbcType=JdbcType.INTEGER),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_amount", property="orderAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_time", property="payTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsMealTableOrder selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsMealTableOrderSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsMealTableOrder record, @Param("example") BsMealTableOrderExample example);

    @UpdateProvider(type=BsMealTableOrderSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsMealTableOrder record, @Param("example") BsMealTableOrderExample example);

    @UpdateProvider(type=BsMealTableOrderSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsMealTableOrder record);

    @Update({
        "update bs_meal_table_order",
        "set mer_id = #{merId,jdbcType=BIGINT},",
          "mer_no = #{merNo,jdbcType=VARCHAR},",
          "mer_name = #{merName,jdbcType=VARCHAR},",
          "mer_abbreviate = #{merAbbreviate,jdbcType=VARCHAR},",
          "store_id = #{storeId,jdbcType=BIGINT},",
          "store_name = #{storeName,jdbcType=VARCHAR},",
          "serial_number = #{serialNumber,jdbcType=VARCHAR},",
          "table_number = #{tableNumber,jdbcType=INTEGER},",
          "`table_name` = #{tableName,jdbcType=VARCHAR},",
          "people_num = #{peopleNum,jdbcType=INTEGER},",
          "order_no = #{orderNo,jdbcType=VARCHAR},",
          "order_amount = #{orderAmount,jdbcType=DECIMAL},",
          "`status` = #{status,jdbcType=INTEGER},",
          "pay_time = #{payTime,jdbcType=TIMESTAMP},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsMealTableOrder record);
}