package com.hfkj.service.meal.impl;

import com.hfkj.dao.BsMealTableOrderMapper;
import com.hfkj.entity.BsMealTableOrder;
import com.hfkj.entity.BsMealTableOrderExample;
import com.hfkj.service.meal.BsMealTableOrderService;
import com.hfkj.sysenum.MealTableOrderStatusEnum;
import com.hfkj.sysenum.MealTableStatusEnum;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

/**
 * @className: BsMealTableOrderServiceImpl
 * @author: HuRui
 * @date: 2023/11/30
 **/
@Service("mealTableOrderService")
public class BsMealTableOrderServiceImpl implements BsMealTableOrderService {

    @Resource
    private BsMealTableOrderMapper mealTableOrderMapper;

    @Override
    public void editData(BsMealTableOrder mealTableOrder) {
        if (mealTableOrder.getId() == null) {
            mealTableOrder.setCreateTime(new Date());
            mealTableOrder.setUpdateTime(new Date());
            mealTableOrderMapper.insert(mealTableOrder);
        } else {
            mealTableOrder.setUpdateTime(new Date());
            mealTableOrderMapper.updateByPrimaryKey(mealTableOrder);
        }
    }

    @Override
    public BsMealTableOrder getCurrentTableOrder(String serialNumber) {
        BsMealTableOrderExample example = new BsMealTableOrderExample();
        example.createCriteria()
                .andSerialNumberEqualTo(serialNumber)
                .andStatusEqualTo(MealTableOrderStatusEnum.status1.getNumber());
        List<BsMealTableOrder> orderList = mealTableOrderMapper.selectByExample(example);
        if (!orderList.isEmpty()) {
            return orderList.get(0);
        }
        return null;
    }
}
